/*
 * Copyright (c) 2003 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

//---------------------------------------------------------------------------
//
//      SusievOCNX
//
//---------------------------------------------------------------------------
#ifndef j2kspi_h
#define j2kspi_h

#include "dllplug.h"
#include "spi00in.h"

//---------------------------------------------------------------------------
//typedef int (__stdcall *GetPluginInfoFunc)(int, LPSTR, int);
//typedef int (__stdcall *ConfigurationDlgFunc)(HWND, int);
typedef int (__stdcall *IsSupportedFunc)(LPSTR, DWORD);
typedef int (__stdcall *GetPictureInfoFunc)(LPSTR, long, DWORD, PictureInfo*);
typedef int (__stdcall *GetPictureFunc)(LPSTR, long, DWORD, HANDLE, HANDLE, SPI_PROGRESS, long);
typedef int (__stdcall *GetPreviewFunc)(LPSTR, long, DWORD, HANDLE, HANDLE, SPI_PROGRESS, long);
class J2kspi : public Dll_plugin
{
public:
/* Common Function */
    //GetPluginInfoFunc GetPluginInfo;
    //ConfigurationDlgFunc ConfigurationDlg;

/* "00IN" Function */
    IsSupportedFunc IsSupported;
    GetPictureInfoFunc GetPictureInfo;
    GetPictureFunc GetPicture;
    //GetPreviewFunc GetPreview;

    J2kspi()
    {
		dll_load("ifj2k.spi");
    };

    ~J2kspi()
    {
    };

    void adress_set(void)
    {
        //GetPluginInfo    = (GetPluginInfoFunc)GetProcAddress(m_handle, "GetPluginInfo");
        IsSupported      = (IsSupportedFunc)GetProcAddress(m_handle, "IsSupported");
        GetPictureInfo   = (GetPictureInfoFunc)GetProcAddress(m_handle, "GetPictureInfo");
        GetPicture       = (GetPictureFunc)GetProcAddress(m_handle, "GetPicture");
        //GetPreview       = (GetPreviewFunc)GetProcAddress(m_handle, "GetPreview");
        //ConfigurationDlg = (ConfigurationDlgFunc)GetProcAddress(m_handle, "ConfigurationDlg");
    };
};

#endif /* j2kspi.h */
